// InfoDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "soprano_m.h"
#include "InfoDlg.h"

#include "StdioDownload.h"
#include "soprano_mView.h"
#include "FileApi.h"
#include "FileString.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CInfoDlg _CAO


CInfoDlg::CInfoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CInfoDlg::IDD, pParent),m_bInit(FALSE)
{
	//{{AFX_DATA_INIT(CInfoDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
	m_pWnd = pParent;
}


void CInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInfoDlg)
	DDX_Control(pDX, IDC_InfoTree, m_cInfoTree);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CInfoDlg, CDialog)
	//{{AFX_MSG_MAP(CInfoDlg)
	ON_WM_SIZE()
	ON_WM_CLOSE()
	ON_NOTIFY(NM_DBLCLK, IDC_InfoTree, OnDblclkInfoTree)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInfoDlg bZ[W nh
/*----------------------------------------------------------------------------*/
//  T  vF  _CAÕRg[̑傫𒲐߂
//    F  void
//  ߂lF  x =  / y = c
//    lF  void
/*----------------------------------------------------------------------------*/
void CInfoDlg::Resize(int x, int y)
{
	m_cInfoTree.MoveWindow(0,0,x,y);
}

/*----------------------------------------------------------------------------*/
//  T  vF  bZ[Wnh֐
//    F  MSNDQ
//  ߂lF  MSDNQ
//    lF  Rg[TCY
/*----------------------------------------------------------------------------*/
void CInfoDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if(m_bInit == TRUE)
	{
		Resize(cx,cy);
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  bZ[Wnh֐
//    F  MSNDQ
//  ߂lF  MSDNQ
//    lF  s
/*----------------------------------------------------------------------------*/
BOOL CInfoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	m_bInit = TRUE;
	Analysis();
	// Õ_CAȌԂ𕜌
	MoveWindow(&m_cRect);
	
	// Rg[̃TCY
	CRect cRect;
	GetClientRect(&cRect);
	Resize(cRect.right,cRect.bottom);
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

/*----------------------------------------------------------------------------*/
//  T  vF  bZ[Wnh֐
//    F  MSNDQ
//  ߂lF  MSDNQ
//    lF  _CAȎ傫ۑ
/*----------------------------------------------------------------------------*/
void CInfoDlg::OnClose() 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	GetWindowRect(&m_cRect);
	
	CDialog::OnClose();
	//OnCancel();
}

void CInfoDlg::Analysis()
{
	vector<HTREEITEM> v_hTree;

	// t@CJ
	CStdioFile cFile(m_cPath,CFile::modeRead);

	// [g擾
	HTREEITEM hRoot = m_cInfoTree.GetRootItem(),hParent,hChild,hFirst = NULL;

	CString cBuf;
	TVINSERTSTRUCT stItem;
	while(cFile.ReadString(cBuf))
	{
		CheckURL(cBuf);

		if(cBuf == _T(""))
		{
			continue;
		}
		else if(cBuf.Left(1) == _T("@"))
		{	
			// @Ŏn܂Ă郋[gɒǉ
			cBuf = cBuf.Mid(1);
			stItem.hParent = hRoot;
			stItem.hInsertAfter = TVI_ROOT;
			stItem.item.mask = TVIF_CHILDREN | TVIF_TEXT;
			stItem.item.pszText = (LPSTR)(LPCTSTR)cBuf;
			stItem.item.cChildren = 1;

			hParent = m_cInfoTree.InsertItem(&stItem);
			hChild = hParent;

			v_hTree.push_back(hParent);
			if(hFirst == NULL)
			{
				hFirst = hParent;
			}
			
		}
		else if(cBuf.Left(1) == _T(_T("*")))
		{
			cBuf = cBuf.Mid(1);
			stItem.hParent = hParent;
			stItem.hInsertAfter = TVI_ROOT;
			stItem.item.mask = TVIF_CHILDREN | TVIF_TEXT;
			stItem.item.pszText = (LPSTR)(LPCTSTR)cBuf;
			stItem.item.cChildren = 1;

			hChild = m_cInfoTree.InsertItem(&stItem);
		}
		else if(cBuf.Left(1) == _T(_T("+")))
		{
			// +Ŏn܂ĂȂqɒǉ
			// ܂+Ƃ
			cBuf = cBuf.Mid(1);
			stItem.hParent = hChild;
			stItem.hInsertAfter = TVI_LAST;
			stItem.item.mask = TVIF_CHILDREN | TVIF_TEXT | TVIF_SELECTEDIMAGE;
			stItem.item.pszText = (LPSTR)(LPCTSTR)cBuf;
			stItem.item.cChildren = 0;
			m_cInfoTree.InsertItem(&stItem);
		}
		else
		{
			m_cID = cBuf;
		}
	}
	// t@C
	cFile.Close();

	for(int i = 0;i < v_hTree.size();i++)
	{
		m_cInfoTree.Expand(v_hTree[i],TVE_EXPAND);
	}
}


void CInfoDlg::CheckURL(CString &cBuf)
{
	int i = cBuf.Find(_T("("));

	if( i != -1)
	{
		CString cUrl,cTitle;

		cUrl = cBuf.Mid(i+1);
		cUrl = cUrl.Left(cUrl.GetLength()-1);
		cBuf = cBuf.Left(i);

		cTitle = cBuf.Mid(1);
		m_mUrl[cTitle] = cUrl;
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  URLݒ肷
//    F  lpURL = URL
//  ߂lF  0
//    lF  void
/*----------------------------------------------------------------------------*/
int CInfoDlg::SetURL(LPCTSTR lpURL)
{
	// t@Cɕۑ
	CStdioDownload cHttp;
	CFileApi cApi;
	CFileString cStr;
	m_cPath = cStr.GetDirName(cApi.GetMyPath());
	m_cPath += _T("info.dat");

	cHttp.SaveFile(lpURL,m_cPath);
	return 0;
}

int CInfoDlg::SetID(LPCTSTR lpID)
{
	m_cPrevID  = lpID;
	return 0;
}

CString CInfoDlg::GetID()
{
	return m_cID;
}

int CInfoDlg::CheckUpdate(LPCTSTR lpURL, LPCTSTR lpID)
{
	SetURL(lpURL);
	
	// ID𓾂
	// t@CJ
	CStdioFile cFile(m_cPath,CFile::modeRead);	

	cFile.ReadString(m_cID);
	cFile.Close();

	if(m_cID == lpID)
	{
		return -1;
	}else{
		return 0;
	}
}

void CInfoDlg::OnDblclkInfoTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
		NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	// c[Rg[ւ̃|C^l
	CTreeCtrl* pTree=(CTreeCtrl*)FromHandle(pNMHDR->hwndFrom);
	
	// Iꂽڂ𓾂
	HTREEITEM hItem = pTree->GetSelectedItem();

	if(hItem)
	{
		CString cTitle = pTree ->GetItemText(hItem);
		CString cUrl = m_mUrl[cTitle];

		if(cUrl != _T(""))
		{
			if(AfxMessageBox(_T("J܂H"),MB_YESNO | MB_ICONQUESTION) == IDYES)
			{

				// VEChEJ
				((CSoprano_mApp*)AfxGetApp())->OnFileNew();
				CMDIFrameWnd *pFrame = (CMDIFrameWnd*)AfxGetMainWnd();
				CMDIChildWnd *pChild = (CMDIChildWnd*)pFrame->GetActiveFrame();
				CSoprano_mView *pView = (CSoprano_mView*)pChild->GetActiveView();

				if(pView != NULL)
				{
					pView->Navigate2(cUrl);
				}
			}
		}
	}
	*pResult = 0;
}


void CInfoDlg::OnCancel()
{
	if(m_pWnd != NULL)
	{
		m_pWnd->PostMessage(WM_COMMAND,ID_VIEW_INFO,0);
	}	
}
