// SopranoIni.cpp: CSopranoIni NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "soprano_m.h"
#include "SopranoIni.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CSopranoIni::CSopranoIni()
:m_nHomeMode(-1),m_nTreeMode(-1),m_nRefreshTiming(-1),m_nTreeOpenMode(-1),m_nAutoCheck(-1),
m_nRefererMode(-1)
{
	memset(&m_cTreeRect,0,sizeof(CRect));

	memset(&m_cBrowseRect,0,sizeof(CRect));

	memset(&m_cInfodlgRect,0,sizeof(CRect));

}

CSopranoIni::~CSopranoIni()
{

}

/*----------------------------------------------------------------------------*/
//  T  vF  z[URL擾
//    F  void
//  ߂lF  0 = IE̐ݒ
//			  1 = ݒ肷
//    lF  void
/*----------------------------------------------------------------------------*/
int CSopranoIni::GetHomeMode()
{
	if(m_nHomeMode != -1)
	{
		// xǂ݂ƂĂȂAԂ
		return m_nHomeMode;
	}else{
		CString cHomeMode;
		cHomeMode =  ReadIni(URL,HOME);

		if(cHomeMode == IE_SETTING)
		{
			// IE̐ݒ𗘗p
			m_nHomeMode = IE;
		}
		else if(cHomeMode == ORIGINAL_SETTING)
		{
			// ݒ肷
			m_nHomeMode = ORIGINAL;
		}
		return m_nHomeMode;
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  z[̃[hݒ肷
//    F  0 = IE̐ݒ
//			  1 = ݒ肷 
//  ߂lF  0 = imEEEj
//    lF  void
/*----------------------------------------------------------------------------*/
int CSopranoIni::SetHomeMode(int nMode)
{
	// obt@ɕۑĂ
	m_nHomeMode = nMode;

	CString cHomeMode;
	switch(nMode)
	{
	case 0:
		cHomeMode = IE_SETTING;
		break;
	case 1:
		cHomeMode = ORIGINAL_SETTING;
		break;
	}

	return WriteIni(URL,HOME,cHomeMode);
}

/*----------------------------------------------------------------------------*/
//  T  vF  ݒ肳ꂽz[y[W擾
//    F  void
//  ߂lF  z[y[WURL
//    lF  void
/*----------------------------------------------------------------------------*/
CString CSopranoIni::GetHome()
{
	if(m_cHomeUrl != _T(""))
	{
		return m_cHomeUrl;
	}else{
		m_cHomeUrl = ReadIni(URL,HOME_URL);
		return m_cHomeUrl;
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  z[y[Wݒ肷
//    F  lpUrl = URL
//  ߂lF  0 = 
//    lF  void
/*----------------------------------------------------------------------------*/
int CSopranoIni::SetHome(LPCTSTR lpUrl)
{
	m_cHomeUrl = lpUrl;
	return WriteIni(URL,HOME_URL,m_cHomeUrl);
}

/*----------------------------------------------------------------------------*/
//  T  vF  G~VURL擾
//    F  void
//  ߂lF  URL
//    lF  void
/*----------------------------------------------------------------------------*/
CString CSopranoIni::GetMoeUrl()
{
	if(m_cMoeUrl != _T(""))
	{
		return m_cMoeUrl;
	}else{
		m_cMoeUrl = ReadIni(URL,MOE_URL);
		return m_cMoeUrl;
	}	
}

/*----------------------------------------------------------------------------*/
//  T  vF  G~VURLݒ肷
//    F  lpUrl = URL
//  ߂lF  0 = 
//    lF  void
/*----------------------------------------------------------------------------*/
int CSopranoIni::SetMoeUrl(LPCTSTR lpUrl)
{
	m_cMoeUrl = lpUrl;

	if(m_cMoeUrl.Right(1) != _T("/"))
	{
		m_cMoeUrl += _T("/");
	}
	return WriteIni(URL,MOE_URL,m_cMoeUrl);
}

/*----------------------------------------------------------------------------*/
//  T  vF  c[̕\@𓾂
//    F  void
//  ߂lF  \@萔
//    lF  void
/*----------------------------------------------------------------------------*/
int CSopranoIni::GetTreeMode()
{
	if(m_nTreeMode != -1)
	{
		return m_nTreeMode;
	}else{
		CString cBuf;
		cBuf = ReadIni(TREE,T_VIEW_MODE);

		if(cBuf == T_DATE)
		{
			m_nTreeMode = V_DATE;
		}
		else if(cBuf == T_SOURCE)
		{
			m_nTreeMode = V_SOURCE;
		}
		else
		{
			m_nTreeMode = V_DOUBLE;
		}

		return m_nTreeMode;
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  c[̕\@ݒ肷
//    F  \@萔
//  ߂lF   = 0
//    lF  void
/*----------------------------------------------------------------------------*/
int CSopranoIni::SetTreeMode(int nMode)
{
	m_nTreeMode = nMode;
	CString cBuf;
	switch(nMode)
	{
	case V_DATE:
		cBuf = T_DATE;
		break;

	case V_SOURCE:
		cBuf = T_SOURCE;
		break;

	case V_DOUBLE:
		cBuf = T_DOUBLE;
		break;
	}
	return WriteIni(TREE,T_VIEW_MODE,cBuf);
}

/*----------------------------------------------------------------------------*/
//  T  vF  c[r[̃TCYݒ肷
//    F  CRectւ̃|C^
//  ߂lF  0@= 
//    lF  void
/*----------------------------------------------------------------------------*/
int CSopranoIni::SetTreeWindowSize(LPRECT lpRect)
{
	m_cTreeRect = *lpRect;

	char chBuf[100];
	CString cBuf;

	_itoa(lpRect->right,chBuf,10);
	cBuf = chBuf;
	WriteIni(SIZE,S_TREE_RIGHT,cBuf);

	_itoa(lpRect->left,chBuf,10);
	cBuf = chBuf;
	WriteIni(SIZE,S_TREE_LEFT,cBuf);
	
	_itoa(lpRect->top,chBuf,10);
	cBuf = chBuf;
	WriteIni(SIZE,S_TREE_TOP,cBuf);

	_itoa(lpRect ->bottom,chBuf,10);
	cBuf =chBuf;
	return WriteIni(SIZE,S_TREE_BOTTOM,cBuf);
}

/*----------------------------------------------------------------------------*/
//  T  vF  c[r[̃TCY擾
//    F  void
//  ߂lF  SIZE
//    lF  void
/*----------------------------------------------------------------------------*/
CRect CSopranoIni::GetTreeWindowSize()
{

	if(m_cTreeRect.top != 0)
	{
		return m_cTreeRect;
	}else{
		m_cTreeRect.right = atoi(ReadIni(SIZE,S_TREE_RIGHT));
		m_cTreeRect.left  = atoi(ReadIni(SIZE,S_TREE_LEFT));
		m_cTreeRect.top   = atoi(ReadIni(SIZE,S_TREE_TOP));
		m_cTreeRect.bottom= atoi(ReadIni(SIZE,S_TREE_BOTTOM));
		return m_cTreeRect;
	}
	
}

/*----------------------------------------------------------------------------*/
//  T  vF  uEUEChȆ傫ݒ肷
//    F  CRectւ̃|C^
//  ߂lF  0 = 
//    lF  void
/*----------------------------------------------------------------------------*/
int CSopranoIni::SetBrowseWindowSize(LPRECT lpRect)
{
	char chBuf[100];
	CString cBuf;

	m_cBrowseRect = *lpRect;

	_itoa(lpRect->right,chBuf,10);
	cBuf = chBuf;
	WriteIni(SIZE,S_BROWSE_X,cBuf);

	_itoa(lpRect ->bottom,chBuf,10);
	cBuf =chBuf;

	return WriteIni(SIZE,S_BROWSE_Y,cBuf);
}


/*----------------------------------------------------------------------------*/
//  T  vF  uEYEChE傫擾
//    F  void
//  ߂lF  CSize
//    lF  void
/*----------------------------------------------------------------------------*/
CSize CSopranoIni::GetBrowseWindowSize()
{
	if(m_cBrowseRect.right != 0)
	{
		CSize cSize(m_cBrowseRect.right,m_cBrowseRect.bottom);
		return cSize;
	}else{
		// ܂x̑傫߂
		int x = atoi(ReadIni(SIZE,S_BROWSE_X));
		int y = atoi(ReadIni(SIZE,S_BROWSE_Y));

		m_cBrowseRect.right = x;
		m_cBrowseRect.bottom = y;

		return CSize(m_cBrowseRect.right,m_cBrowseRect.bottom);

	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  XV^C~O𓾂
//    F  void
//  ߂lF  ^C~O\萔
//    lF  void
/*----------------------------------------------------------------------------*/
int CSopranoIni::GetRefreshTiming()
{
	if(m_nRefreshTiming != -1)
	{
		return m_nRefreshTiming;
	}else{
		CString cBuf = ReadIni(TREE,T_REFRESH_TIMING);

		if(cBuf == T_ALL)
		{
			m_nRefreshTiming = ALL;
		}
		else if(cBuf == T_NONE)
		{
			m_nRefreshTiming = NONE;
		}

		return m_nRefreshTiming;
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  [c[]XV^C~Oݒ肷
//    F  XV^C~O萔
//  ߂lF   = 0
//    lF  void
/*----------------------------------------------------------------------------*/
int CSopranoIni::SetRefreshTiming(int nTime)
{
	m_nRefreshTiming = nTime;

	CString cBuf;

	switch(nTime)
	{
	case ALL:
		cBuf = T_ALL;
		break;
	case NONE:
		cBuf = T_NONE;
		break;
	}

	return WriteIni(TREE,T_REFRESH_TIMING,cBuf);
}

int CSopranoIni::SetInfoUrl(LPCTSTR lpUrl)
{
	m_cInfoUrl = lpUrl;

	return WriteIni(INFO,URL,m_cInfoUrl);
}

/*----------------------------------------------------------------------------*/
//  T  vF  um点vgURL擾
//    F  void
//  ߂lF  URL
//    lF  void
/*----------------------------------------------------------------------------*/
CString CSopranoIni::GetInfoUrl()
{
	if(m_cInfoUrl != _T(""))
	{
		return m_cInfoUrl;
	}else{
		m_cInfoUrl = ReadIni(INFO,URL);
		return m_cInfoUrl;
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  [m点]_CAȎ傫擾
//    F  void
//  ߂lF  傫
//    lF  void
/*----------------------------------------------------------------------------*/
CRect CSopranoIni::GetInfoDlgRect()
{
	if(m_cInfodlgRect.top != 0)
	{
		return m_cInfodlgRect;
	}else{
		m_cInfodlgRect.right = atoi(ReadIni(SIZE,S_INFO_RIGHT));
		m_cInfodlgRect.left  = atoi(ReadIni(SIZE,S_INFO_LEFT));
		m_cInfodlgRect.top   = atoi(ReadIni(SIZE,S_INFO_TOP));
		m_cInfodlgRect.bottom= atoi(ReadIni(SIZE,S_INFO_BOTTOM));
		return m_cInfodlgRect;
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  [m点]_CAȎ傫ݒ肷
//    F  CRectւ̃|C^
//  ߂lF  0 = 
//    lF  void
/*----------------------------------------------------------------------------*/
int CSopranoIni::SetInfoDlgRect(LPRECT lpRect)
{
	m_cInfodlgRect = *lpRect;

	char chBuf[100];
	CString cBuf;

	_itoa(lpRect->right,chBuf,10);
	cBuf = chBuf;
	WriteIni(SIZE,S_INFO_RIGHT,cBuf);

	_itoa(lpRect->left,chBuf,10);
	cBuf = chBuf;
	WriteIni(SIZE,S_INFO_LEFT,cBuf);
	
	_itoa(lpRect->top,chBuf,10);
	cBuf = chBuf;
	WriteIni(SIZE,S_INFO_TOP,cBuf);

	_itoa(lpRect ->bottom,chBuf,10);
	cBuf =chBuf;
	return WriteIni(SIZE,S_INFO_BOTTOM,cBuf);

}

/*----------------------------------------------------------------------------*/
//  T  vF  [c[]URL̊J擾
//    F  void
//  ߂lF  SELETED = I,DCLICK = _uNbN
//    lF  
/*----------------------------------------------------------------------------*/
int CSopranoIni::GetTreeOpenMode()
{
	if(m_nTreeOpenMode != -1)
	{
		return m_nTreeOpenMode;
	}else{
		CString cBuf = ReadIni(TREE,T_OPEN_MODE);

		if(cBuf == T_SELECT)
		{
			m_nTreeOpenMode = SELECTED;
		}
		else if(cBuf == T_DCLICK)
		{
			m_nTreeOpenMode = DCLICK;
		}

		return m_nTreeOpenMode;

	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  [c[]URL̊J擾
//    F  SELETED = I,DCLICK = _uNbN
//  ߂lF  
//    lF  
/*----------------------------------------------------------------------------*/
int CSopranoIni::SetTreeOpenMode(int nMode)
{
	m_nTreeOpenMode = nMode;

	CString cBuf;

	switch(m_nTreeOpenMode)
	{
	case SELECTED:
		cBuf = T_SELECT;
		break;
	case DCLICK:
		cBuf = T_DCLICK;
		break;
	}
	return WriteIni(TREE,T_OPEN_MODE,cBuf);
}

BOOL CSopranoIni::GetAutoCheck()
{
	if(m_nAutoCheck != -1)
	{
		if(m_nAutoCheck == 0)
		{
			return TRUE;
		}else{
			return FALSE;
		}
	}else{
		CString cBuf = ReadIni(INFO,AUTO_CHECK);
		BOOL bBuf;

		if(cBuf == ENABLE)
		{
			bBuf = TRUE;
			m_nAutoCheck = 0;
		}
		else if(cBuf == DISABLE)
		{
			bBuf = FALSE;
			m_nAutoCheck = 1;
		}

		return bBuf;
	}
}

int CSopranoIni::SetAutoCheck(BOOL b)
{
	if(b == TRUE)
	{
		m_nAutoCheck = 0;
		return WriteIni(INFO,AUTO_CHECK,ENABLE);
	}else{
		m_nAutoCheck = 1;
		return WriteIni(INFO,AUTO_CHECK,DISABLE);
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  [Info]IDݒ肷
//    F  lpID = ID
//  ߂lF  0 = 
//    lF  void
/*----------------------------------------------------------------------------*/
int CSopranoIni::SetInfoID(LPCTSTR lpID)
{
	m_cInfoID = lpID;

	return WriteIni(INFO,ID,m_cInfoID);	
}

/*----------------------------------------------------------------------------*/
//  T  vF  [Info]ID擾
//    F  void
//  ߂lF  ID
//    lF  void
/*----------------------------------------------------------------------------*/
CString CSopranoIni::GetInfoID()
{
	if(m_cInfoID != _T(""))
	{
		return m_cInfoID;
	}else{
		m_cInfoID = ReadIni(INFO,ID);
		return m_cInfoID;
	}
}

void CSopranoIni::SetToolbarRect(LPRECT lpRect)
{
	char chBuf[100];
	CString cBuf;

	_itoa(lpRect->right,chBuf,10);
	cBuf = chBuf;
	WriteIni(SIZE,S_TOOLBAR_RIGHT,cBuf);

	_itoa(lpRect->left,chBuf,10);
	cBuf = chBuf;
	WriteIni(SIZE,S_TOOLBAR_LEFT,cBuf);
	
	_itoa(lpRect->top,chBuf,10);
	cBuf = chBuf;
	WriteIni(SIZE,S_TOOLBAR_TOP,cBuf);

	_itoa(lpRect ->bottom,chBuf,10);
	cBuf =chBuf;
	WriteIni(SIZE,S_TOOLBAR_BOTTOM,cBuf);
}

CRect CSopranoIni::GetToolbarRect()
{
	CRect cRect;
	cRect.right = atoi(ReadIni(SIZE,S_TOOLBAR_RIGHT));
	cRect.left  = atoi(ReadIni(SIZE,S_TOOLBAR_LEFT));
	cRect.top   = atoi(ReadIni(SIZE,S_TOOLBAR_TOP));
	cRect.bottom= atoi(ReadIni(SIZE,S_TOOLBAR_BOTTOM));
	
	return cRect;
}

void CSopranoIni::SetAddressRect(LPRECT lpRect)
{
	char chBuf[100];
	CString cBuf;

	_itoa(lpRect->right,chBuf,10);
	cBuf = chBuf;
	WriteIni(SIZE,S_ADDRESS_RIGHT,cBuf);

	_itoa(lpRect->left,chBuf,10);
	cBuf = chBuf;
	WriteIni(SIZE,S_ADDRESS_LEFT,cBuf);
	
	_itoa(lpRect->top,chBuf,10);
	cBuf = chBuf;
	WriteIni(SIZE,S_ADDRESS_TOP,cBuf);

	_itoa(lpRect ->bottom,chBuf,10);
	cBuf =chBuf;
	WriteIni(SIZE,S_ADDRESS_BOTTOM,cBuf);

}

CRect CSopranoIni::GetAddressRect()
{
	CRect cRect;
	cRect.right = atoi(ReadIni(SIZE,S_ADDRESS_RIGHT));
	cRect.left  = atoi(ReadIni(SIZE,S_ADDRESS_LEFT));
	cRect.top   = atoi(ReadIni(SIZE,S_ADDRESS_TOP));
	cRect.bottom= atoi(ReadIni(SIZE,S_ADDRESS_BOTTOM));
	
	return cRect;
}

/*----------------------------------------------------------------------------*/
//  T  vF  t\𓾂
//    F  void
//  ߂lF  
//    lF  "%y%m...."݂ȂȊ
/*----------------------------------------------------------------------------*/
CString CSopranoIni::GetDateFormat()
{
	if(m_cDateFormat != _T(""))
	{
		return m_cDateFormat;
	}else{
		m_cDateFormat = ReadIni(TREE,T_DATE_FORMAT);

		return m_cDateFormat;
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  t̕\
//    F  
//  ߂lF  0 = 
//    lF  void
/*----------------------------------------------------------------------------*/
int CSopranoIni::SetDateFormat(LPCTSTR lpFormat)
{
	m_cDateFormat  = lpFormat;

	return WriteIni(TREE,T_DATE_FORMAT,m_cDateFormat);
}

/*----------------------------------------------------------------------------*/
//  T  vF  UA̎擾
//    F  void
//  ߂lF  UA
//    lF  void
/*----------------------------------------------------------------------------*/
CString CSopranoIni::GetUserAgent()
{
	if(m_cUserAgent != _T(""))
	{
		return m_cUserAgent;
	}else{
		m_cUserAgent = ReadIni(WEB,W_UA);

		return m_cUserAgent;
	}
}

CString CSopranoIni::GetReferer()
{
	if(m_cReferer != _T(""))
	{
		return m_cReferer;
	}else{
		m_cReferer = ReadIni(WEB,W_REF);

		return m_cReferer;
	}
}

int CSopranoIni::SetUserAgent(LPCTSTR lpUA)
{
	m_cUserAgent = lpUA;

	return WriteIni(WEB,W_UA,m_cUserAgent);
}

int CSopranoIni::SetReferer(LPCTSTR lpRef)
{
	m_cReferer = lpRef;

	return WriteIni(WEB,W_REF,m_cReferer);
}




int CSopranoIni::GetReferMode()
{
	if(m_nRefererMode != -1)
	{
		return m_nRefererMode;
	}else{
		CString cBuf;
		cBuf = ReadIni(WEB,W_REF_MODE);

		if(cBuf == W_REF_AUTO)
		{
			m_nRefererMode = 0;
		}
		else if(cBuf == W_REF_MUN)
		{
			m_nRefererMode = 1;
		}
		return m_nRefererMode;
	}
}

int CSopranoIni::SetRefererMode(int nMode)
{
	m_nRefererMode = nMode;

	CString cBuf;
	switch(m_nRefererMode)
	{
	case 0:
		cBuf = W_REF_AUTO;
		break;
	case 1:
		cBuf = W_REF_MUN;
	}

	return WriteIni(WEB,W_REF_MODE,cBuf);
}
