// TreeData.h: CTreeData NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TREEDATA_H__8D46CD09_AC8B_4242_AD26_06381EF187A4__INCLUDED_)
#define AFX_TREEDATA_H__8D46CD09_AC8B_4242_AD26_06381EF187A4__INCLUDED_

#include "SopranoIni.h"	// ClassView ɂĒǉ܂B
#include "MoeTop.h"	// ClassView ɂĒǉ܂B
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
/*----------------------------------------------------------------------------*/
//  Tv        F  c[o[̃f[^Ǘ
//  ֘AtH[F  void
//  l        F  ܂sS
/*----------------------------------------------------------------------------*/
#include "map"
using namespace std;

class CTreeData  
{
public:
	int AddTime(CTime cFrom, CTime cTo);
	virtual int GetTime(CTime& rFrom,CTime &rTo);
	virtual void MoeClear();
	virtual CString GetURL(LPCTSTR lpTitle);
	virtual int SetTime(CTime cFrom,CTime cTo);
	virtual HTREEITEM GetTreeItem(CString cKey);
	virtual int SetTreeItem(CString cTitle,HTREEITEM hItem);
	virtual int FindTreeItem(CString cKey);
	virtual CMoeFile* GetMoeFile(int nIndex);
	virtual int GetMoeMax();
	virtual int ClearItemList();
	virtual CSopranoIni* GetData();
	virtual CMoeTop* GetMoe();
	CTreeData();
	virtual ~CTreeData();

private:
	CTime m_cFromTime;
	CTime m_cToTime;
	CMoeTop *m_pMoe;
	CSopranoIni *m_pData;
	map<CString,HTREEITEM> m_mTreeItem;
protected:
	virtual int AnalysisLog(int nYear,int nMonth);
};

#endif // !defined(AFX_TREEDATA_H__8D46CD09_AC8B_4242_AD26_06381EF187A4__INCLUDED_)
