// main.cpp
#include "StdAfx.h"
#include "main.h"
#include "sdk.h"

//----------------------------------------------------------------------------//
//  T  vF  ͂s
//    F  str = ͂镶 , res = ʂ̕
//  ߂lF  ނ萔
//    lF  OɌJ֐
//----------------------------------------------------------------------------//
int WINAPI MoeAnalysis(LPCTSTR str,LPSTR res)
{
	CString cStr = str;

	if(cStr == "<a name=111517><h1>200208-111517</h1>")
	{
		cStr = _T("");
	}
	CString cBuf;
	int nRes = A_NONE;

	if(CheckDate(str , cBuf))
	{
		// t
		nRes = A_DATE;
	}
	else if(CheckSource(str,cBuf))
	{
		// \[X
		nRes = A_SOURCE;
	}
	else if(CheckTitle(str , cBuf))
	{
		// ^Cg
		nRes = A_TITLE;
	}
	else if(CheckUrl(str , cBuf))
	{
		// URL
		// A_URLԂď߂āAc[ɒǉ
		nRes = A_URL;
	}
	
	strcpy(res,cBuf);
	return nRes;
}

//----------------------------------------------------------------------------//
//  T  vF  ÕXy[X菜
//    F  Ȃ
//  ߂lF  Ȃ
//    lF  Tu[`
//----------------------------------------------------------------------------//
void Trim(CString &cStr)
{
	cStr.TrimLeft();
	cStr.TrimRight();
	cStr.Replace(_T("@"),_T(""));
}

//----------------------------------------------------------------------------//
//  T  vF  tǂ`FbN
//    F  cStr = ͂镶 , r_cBuffer = ʂobt@
//  ߂lF  ^ = t
//    lF  obt@ɂ"200208-140022"̂悤ȕ
//----------------------------------------------------------------------------//
BOOL CheckDate(CString cStr , CString &r_cBuffer)
{
	// tɑ啶͊֌WȂ̂ŁAׂďɂB(^OFh~)
	cStr.MakeLower();

	// ɃXy[XvȂ
	Trim(cStr);

	// t<h1></h1>ň͂܂Ă
	int nStart = cStr.Find(_T("<h1"));
	int nEnd   = cStr.Find(_T("</h1>"));


	if(nStart == -1 || nEnd == -1)
	{
		// <h1>܂</h1>܂łȂ
		return FALSE;
	}else{
		// ^O
		nStart = cStr.Find(">") + 1;
		nEnd = cStr.Find("<",nStart);

		r_cBuffer = cStr.Mid(nStart,nEnd - nStart);
		//AfxMessageBox(r_cBuffer);
		return TRUE;
	}
}

//----------------------------------------------------------------------------//
//  T  vF  \[Xǂ`FbN
//    F  cStr = ͂镶 , r_cBuffer = ʂobt@
//  ߂lF  ^ = \[X
//    lF  ԕύX̂ŏ_悤
//----------------------------------------------------------------------------//
BOOL CheckSource(CString cStr,CString &r_cBuffer)
{
	
	// class"s"̃N\[XȂ̂ł܂̓`FbN
	if(cStr.Find(_T("<a")) == -1 || cStr.Find("class=\"s\"") == -1)
	{
		// ̂̎̏̃R[h
		// OIɁAN̒ĂȂ\[X̏ꍇ́AŏXy[XŎn܂ĂȂB
		if(cStr.Left(strlen(_T("@"))) != _T("@") && cStr.Left(strlen(_T("<"))) != _T("<"))
		{
			int n= cStr.Find(_T("<"));

			if(n != -1)
			{
				cStr = cStr.Left(n);
			}
			r_cBuffer = cStr;
			return TRUE;
		}else{
			return FALSE;
		}
	}else{
		// N̒Ă镶𒊏o
		int nStart = cStr.Find(_T(">"));
		int nEnd   = cStr.Find(_T("<"),nStart);

		r_cBuffer = cStr.Mid(nStart + 1 , nEnd - (nStart +1));
		return TRUE;
	}
}

//----------------------------------------------------------------------------//
//  T  vF  ^Cgǂ`FbN
//    F  cStr = ͂镶 , r_cBuffer = ʂobt@
//  ߂lF  ^ = ^Cg
//    lF  ȂĈԂ
//----------------------------------------------------------------------------//
BOOL CheckTitle(CString cStr, CString &r_cBuffer)
{
	// ͓Ȃ̂
	// ܂AB̃^Oł<br>Ĉ؃^O܂܂ĂȂȂ^CgƂ
	Trim(cStr);
	cStr.MakeLower();
	
	// <br>̍폜
	cStr.Replace(_T("<br>"),_T(""));
	
	CString cBuf;
	if(cStr.Find(_T("<")) == -1 && cStr != _T("") && CheckUrl(cStr,cBuf)==FALSE)
	{
		// ^O܂܂ĂȂAyURLłȂ
		r_cBuffer = cStr;
		return TRUE;
	}else{
		return FALSE;
	}
}

//----------------------------------------------------------------------------//
//  T  vF  URLǂ`FbN
//    F  cStr = ͂镶 , r_cBuffer = ʂobt@
//  ߂lF  ^ = URL
//    lF  
//----------------------------------------------------------------------------//
BOOL CheckUrl(CString cStr , CString &r_cBuffer)
{
	// zCgXy[X
	Trim(cStr);

	// N܂܂Ă邩`FbN
	int i = cStr.Find(_T("<a href=\""));
	
	
	if( i != -1)
	{
		// ܂܂ĂȂVtH[}bg̉\
		// ܂">"ȍ~擾
		i = cStr.Find(_T(">"));
		cStr = cStr.Mid(i+1);

		// </a><br><br>
		cStr.Replace(_T("</a><br><br>"),_T(""));
	}

	// 擪http://Ŏn܂B[tH[}bg]
	if(cStr.Left(strlen(_T("http://"))) == _T("http://"))
	{
		r_cBuffer = cStr;

		// Xy[XȂ炻܂
		int n=cStr.Find(_T(" "));
		if(n != -1)
		{
			r_cBuffer = cStr.Left(n);
		}

		n = cStr.Find(_T("<"));
		if(n != -1)
		{
			r_cBuffer = cStr.Left(n);
		}

		return TRUE;
	}
	else
	{
		return FALSE;
	}
}