// MainFrm.cpp : CMainFrame NX̓̒`s܂B
//

#include "stdafx.h"
#include "soprano_m.h"


#include "MainFrm.h"
#include "soprano_mView.h"
#include "soprano_mDoc.h"
#include "InfoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_SETTING, OnSetting)
	ON_WM_CLOSE()
	ON_COMMAND(ID_VIEW_INFO, OnViewInfo)
	ON_COMMAND(ID_GO_MAD, OnGoMad)
	ON_COMMAND(ID_TREE_REFRESH, OnTreeRefresh)
	ON_COMMAND(ID_VIEW_TREE, OnViewTree)
	ON_UPDATE_COMMAND_UI(ID_VIEW_TREE, OnUpdateViewTree)
	ON_COMMAND(ID_TREE_FOCUS, OnTreeFocus)
	ON_COMMAND(ID_VIEW_TIME, OnViewTime)
	ON_COMMAND(dID_ViewDebugDlg, dOnViewDebugDlg)
	//}}AFX_MSG_MAP
	ON_COMMAND(IDOK, OnNewAddressEnter)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // Xe[^X C CWP[^
	ID_INDICATOR_KANA,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̍\z/

CMainFrame::CMainFrame()
:m_bTreeBar(TRUE),m_pInfoDlg(NULL),m_pDebugDlg(NULL)
{	// TODO: ̈ʒuɃȍR[hǉĂB
	m_pData= new CSopranoIni;
	m_pMoe = new CMoeTop;
}

CMainFrame::~CMainFrame()
{
	delete m_pData;
	delete m_pMoe;
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndToolBar.CreateEx(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // 쐬Ɏs
	}
/*	if (!m_wndDlgBar.Create(this, IDR_MAINFRAME, 
		CBRS_ALIGN_TOP, AFX_IDW_DIALOGBAR))
	{
		TRACE0("Failed to create dialogbar\n");
		return -1;		// 쐬Ɏs
	}*/
	
	if (!m_wndReBar.Create(this))
	{
		TRACE0("Failed to create rebar\n");
		return -1;      // fail to create
	}
	
/*	if (!m_wndReBar.Create(this) ||
		!m_wndReBar.AddBar(&m_wndToolBar) ||
		!m_wndReBar.AddBar(&m_wndDlgBar))
	{
		TRACE0("Failed to create rebar\n");
		return -1;      // 쐬Ɏs
	}*/

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // 쐬Ɏs
	}

	 if (CMDITabFrameWnd::CreateTabs() == -1)
		return -1;

	
	// TODO: c[ `bvXKvȂꍇA폜ĂB
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY);

	// create a combo box for the address bar
	if (!m_wndAddress.Create(CBS_DROPDOWN | WS_CHILD, CRect(0, 0, 200, 120), this, AFX_IDW_TOOLBAR + 1))
	{
		TRACE0("Failed to create combobox\n");
		return -1;      // fail to create
	}

	// o[ɂ낢ǉ
	m_wndReBar.AddBar(&m_wndToolBar);
//	m_wndReBar.AddBar(&m_wndAnimate, NULL, NULL, RBBS_FIXEDSIZE | RBBS_FIXEDBMP);
	m_wndReBar.AddBar(&m_wndAddress, "URL:", NULL, RBBS_FIXEDBMP | RBBS_BREAK);


	CreateTreeBar();
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: ̈ʒu CREATESTRUCT cs CāAWindow NXX^C
	//       CĂB

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̐ff

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame bZ[W nh

/*----------------------------------------------------------------------------*/
//  T  vF  AhXo[ɕ\URLݒ肷
//    F  lpUrl = URL
//  ߂lF  void
//    lF  ɂǉ
/*----------------------------------------------------------------------------*/
void CMainFrame::SetUrl(LPCTSTR lpUrl)
{
	// AhXo[ɕ\
	m_wndAddress.SetWindowText(lpUrl);

	COMBOBOXEXITEM item;

	item.mask = CBEIF_TEXT;
	item.iItem = -1;
	item.pszText = (LPTSTR)lpUrl;
	m_wndAddress.InsertItem(&item);
}

/*----------------------------------------------------------------------------*/
//  T  vF  uݒṽbZ[Wnh֐
//    F  void
//  ߂lF  void
//    lF  ݒ_CAO\
/*----------------------------------------------------------------------------*/
void CMainFrame::OnSetting() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CSettingSheet cSheet(_T("ݒ"));

	LoadSetting(&cSheet);

	if(cSheet.DoModal() == IDOK)
	{
		SaveSetting(&cSheet);
	}
}	
	
/*----------------------------------------------------------------------------*/
//  T  vF  ݒ[h
//    F  CSettingSheetւ̃|C^
//  ߂lF  void
//    lF  void
/*----------------------------------------------------------------------------*/
void CMainFrame::LoadSetting(CSettingSheet *pSheet)
{
	CPropertyPage* pPage;

	CMainPage* pMain;
	CTreePage* pTree;
	CWebPage *pWeb;
	CHeadlinePage *pHead;

	for(int i=0 ; i < pSheet->GetPageCount() ; i++)
	{
		pPage = pSheet->GetPage(i);

		switch(i)
		{
		case MAIN_PAGE:
			// [URL]y[W
			pMain = (CMainPage*)pPage;
			pMain->m_nStartMode = m_pData->GetHomeMode();
			pMain->m_cStartUrl = m_pData ->GetHome();
			pMain->m_cMoeUrl = m_pData->GetMoeUrl();
			break;

		case WEB_PAGE:
			pWeb = (CWebPage*)pPage;
			pWeb->m_cRefer = m_pData->GetReferer();
			pWeb->m_nRefer = m_pData->GetReferMode();
			pWeb->m_cUserAgent = m_pData->GetUserAgent();
			break;
		case TREE_PAGE:
			pTree = (CTreePage*)pPage;
			pTree ->m_nViewMode = m_pData->GetTreeMode();
			//pTree ->m_nRefreshTiming = pIni ->GetRefreshTiming();
			pTree ->m_nOpenMode = m_pData->GetTreeOpenMode();
			pTree ->m_cDateFormat = m_pData->GetDateFormat();
			break;

		case HEADLINE_PAGE:
			pHead = (CHeadlinePage*)pPage;
			pHead ->m_cUrl = m_pData ->GetInfoUrl();
			pHead ->m_bAutoCheck = m_pData ->GetAutoCheck();
			break;

		}
	}
}

void CMainFrame::SaveSetting(CSettingSheet *pSheet)
{
	CPropertyPage* pPage;

	CMainPage* pMain;
	CTreePage *pTree;
	CHeadlinePage *pHead;
	CWebPage *pWeb;

	for(int i=0 ; i < pSheet->GetPageCount() ; i++)
	{
		pPage = pSheet->GetPage(i);
		
		switch(i)
		{
		case MAIN_PAGE:
			// [URL]y[W
			pMain = (CMainPage*)pPage;
			m_pData->SetHomeMode(pMain->m_nStartMode);
			m_pData->SetHome(pMain ->m_cStartUrl);
			m_pData->SetMoeUrl(pMain->m_cMoeUrl);
			break;
		case WEB_PAGE:
			pWeb = (CWebPage*)pPage;
			m_pData->SetRefererMode(pWeb->m_nRefer);
			m_pData->SetReferer(pWeb->m_cRefer);
			m_pData->SetUserAgent(pWeb->m_cUserAgent);
			break;
		case TREE_PAGE:
			pTree = (CTreePage*)pPage;
			m_pData->SetTreeMode(pTree->m_nViewMode);
		//	pIni->SetRefreshTiming(pTreePage->m_nRefreshTiming);
			m_pData->SetTreeOpenMode(pTree->m_nOpenMode);
			m_pData->SetDateFormat(pTree->m_cDateFormat);
			break;

		case HEADLINE_PAGE:
			pHead = (CHeadlinePage*)pPage;
			m_pData ->SetInfoUrl(pHead ->m_cUrl);
			m_pData ->SetAutoCheck(pHead->m_bAutoCheck);
			break;
		}
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  ݒɎgCSopranoIniւ̃|C^擾
//    F  void
//  ߂lF  void
//    lF  void
/*----------------------------------------------------------------------------*/
CSopranoIni* CMainFrame::GetData()
{
	return m_pData;
}

void CMainFrame::OnNewAddressEnter()
{
	CString str;

	m_wndAddress.GetEditCtrl()->GetWindowText(str);

	if(str !="")
	{
		CMDIChildWnd *pChild = (CMDIChildWnd*)GetActiveFrame();
		CSoprano_mView *pView = (CSoprano_mView*)pChild->GetActiveView();

		pView->Navigate2(str, 0, NULL);

		COMBOBOXEXITEM item;

		item.mask = CBEIF_TEXT;
		item.iItem = -1;
		item.pszText = (LPTSTR)(LPCTSTR)str;
		m_wndAddress.InsertItem(&item);
	}


}

void CMainFrame::OnClose() 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ

	CRect cRect;
	m_wndTreeBar.GetClientRect(&cRect);
	m_pData->SetTreeWindowSize(&cRect);
	CMDIFrameWnd::OnClose();
}

/*----------------------------------------------------------------------------*/
//  T  vF  um点ṽbZ[Wnh֐
//    F  MSNDQ
//  ߂lF  MSDNQ
//    lF  m点p̃_CAO\
/*----------------------------------------------------------------------------*/
void CMainFrame::OnViewInfo() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	ViewInfo();
	
}	
	

void CMainFrame::ViewInfo()
{
/*	CInfoDlg cDlg;

	// Ȏ傫ݒ
	cDlg.m_cRect = m_pData ->GetInfoDlgRect();
	
	cDlg.SetID(m_pData ->GetInfoID());		// IDݒ
	cDlg.SetURL(m_pData->GetInfoUrl());		// URLݒ	

	cDlg.DoModal();
	
	// 傫ۑ
	m_pData ->SetInfoDlgRect(cDlg.m_cRect);

	// IDۑ
	m_pData ->SetInfoID(cDlg.GetID());*/

	if(m_pInfoDlg == NULL)
	{
		m_pInfoDlg = new CInfoDlg(this);

		m_pInfoDlg->m_cRect = m_pData->GetInfoDlgRect();
		m_pInfoDlg->SetID(m_pData->GetInfoID());
		m_pInfoDlg->SetURL(m_pData->GetInfoUrl());

		m_pInfoDlg->Create(IDD_IINFO_DLG,this);
		m_pInfoDlg->ShowWindow(SW_SHOW);
	}else{
		m_pInfoDlg->DestroyWindow();
		delete m_pInfoDlg;

		m_pInfoDlg = NULL;
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  CMoeTopւ̃|C^擾
//    F  void
//  ߂lF  CMoeTop*
//    lF  void
/*----------------------------------------------------------------------------*/
CMoeTop* CMainFrame::GetMoe()
{
	return m_pMoe;
}

/*----------------------------------------------------------------------------*/
//  T  vF  c[o[쐬
//    F  void
//  ߂lF  void
//    lF  Tu[`
/*----------------------------------------------------------------------------*/
void CMainFrame::CreateTreeBar()
{
	// hbLOEChE̒ǉ
	EnableDocking(CBRS_ALIGN_ANY);

	m_wndTreeBar.SetSizeDockStyle(SZBARF_STDMOUSECLICKS | SZBARF_DLGAUTOSIZE); 

	if (!m_wndTreeBar.Create(this, IDD_TREE_DLG,
		CBRS_LEFT | CBRS_HIDE_INPLACE,
		ID_VIEW_TREE))
	{
		TRACE0("Failed to create dialog bar m_wndTreeBar\n");
		return;		// fail to create
	}
	m_wndTreeBar.m_VertDockSize = m_pData->GetTreeWindowSize().right;

    // and dock it
	m_wndTreeBar.EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndTreeBar);

	// -------------- ݒs ------------------
	m_wndTreeBar.SetURL(m_pData->GetMoeUrl());
	m_wndTreeBar.SetTreeMode(m_pData->GetTreeMode());

	m_wndTreeBar.Init();

}

/*----------------------------------------------------------------------------*/
//  T  vF  uy[WṽbZ[Wnh֐
//    F  void
//  ߂lF  void
//    lF  ֐󂷂ƁAwCxBMadProgrammerLabȁEEE
/*----------------------------------------------------------------------------*/
void CMainFrame::OnGoMad() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
//	((CSoprano_mApp*)AfxGetApp())->OnFileNew();
//	CMDIChildWnd *pChild = (CMDIChildWnd*)GetActiveFrame();
//	CSoprano_mView *pView = (CSoprano_mView*)pChild->GetActiveView();

//	pView->Navigate2(MAD_URL, 0, NULL);
	ShellExecute(NULL,"open",MAD_URL,NULL,NULL,SW_NORMAL);
}



void CMainFrame::OnTreeRefresh() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	m_wndTreeBar.RefreshTree();
}


/*----------------------------------------------------------------------------*/
//  T  vF  uc[\ṽbZ[Wnh֐
//    F  MSDNQ
//  ߂lF  MSDNQ
//    lF  c[o[̕\E\؂ւ
/*----------------------------------------------------------------------------*/
void CMainFrame::OnViewTree() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(m_bTreeBar == TRUE)
	{
		m_bTreeBar = FALSE;	
	}else{
		m_bTreeBar = TRUE;
	}

	ShowControlBar(&m_wndTreeBar,m_bTreeBar,FALSE);
}

/*----------------------------------------------------------------------------*/
//  T  vF  uc[̕\ṽbZ[Wnh֐
//    F  MSDNQ
//  ߂lF  MSDNQ
//    lF  `FbNE`FbN̐؂ւ
/*----------------------------------------------------------------------------*/
void CMainFrame::OnUpdateViewTree(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	pCmdUI->SetCheck(m_bTreeBar);
}

/*----------------------------------------------------------------------------*/
//  T  vF  utH[JXڂvbZ[Wnh֐
//    F  MSDNQ
//  ߂lF  MSDNQ
//    lF  c[o[ANeBuɂ
/*----------------------------------------------------------------------------*/
void CMainFrame::OnTreeFocus() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	m_wndTreeBar.SetFocus();
}

void CMainFrame::OnViewTime() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	m_wndTreeBar.ViewTimeDlg();
}

void CMainFrame::SetStatusText(LPCTSTR lpText)
{
	m_wndStatusBar.GetStatusBarCtrl().SetText(lpText,0,SBT_NOBORDERS);	
}

void CMainFrame::dOnViewDebugDlg() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(m_pDebugDlg == NULL)
	{
		m_pDebugDlg = new CDebugDlg(this);

		m_pDebugDlg->Create(IDD_DebugDlg,this);
		m_pDebugDlg->ShowWindow(SW_SHOW);
	}else{
		m_pDebugDlg->DestroyWindow();
		delete m_pDebugDlg;
	}
}
