// MoeTop.cpp: CMoeTop NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "soprano_m.h"
#include "MoeTop.h"

// ֐NX
#include <FileString.h>
#include <FileApi.h>
#include "StdioDownload.h"
#include "AnalysisEngine.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CMoeTop::CMoeTop()
:m_nMax(0)
{

}

CMoeTop::~CMoeTop()
{
	// m_liFileɊmۂꂽCMoeFile*ׂĉ
	IT_FILE itFile;

	for(itFile = m_liFile.begin() ;itFile != m_liFile.end() ; itFile++)
	{
		delete *itFile;
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  G~Ṽgbvy[WURLw肷B
//    F  lpUrl = URL , nMode = ͂̎d(ȗ)
//  ߂lF   = 0
//    lF  CMoeFilêƍȂ悤
/*----------------------------------------------------------------------------*/
int CMoeTop::SetUrl(LPCTSTR lpUrl,int nAnalysisMode)
{

	// URL̐ݒ
	m_stLoadStruct.cUrl = lpUrl;

	// _E[ht@C擾
	

	CString cURL = CStdioDownload::GetUrlPathName(lpUrl);
	cURL.Replace(_T("/"),_T("_"));
	CFileApi cApi;
	CFileString cStr;
	CString cPath = cStr.GetDirName(cApi.GetMyPath());
	cPath += cURL + _T(".moe");

	// _E[hyщ
	Download(nAnalysisMode,cPath,lpUrl);

	return 0;
}


/*----------------------------------------------------------------------------*/
//  T  vF  LbV(G~Ṽgbvy[W)͂
//    F  void
//  ߂lF   = 0
//    lF  void
/*----------------------------------------------------------------------------*/
int CMoeTop::ChacheAnalysis(LPCTSTR lpPath)
{
	// t@CJ
	CStdioFile cFile;
	CFileException e;

	if(!cFile.Open(lpPath,CFile::modeRead,&e))
	{
#if _DEBUG
		afxDump << "File could not be opened " << e.m_cause << "\n";
#endif // _DEBUG
		return -1;
	}

	CString cDate,cSource,cTitle,cUrl;

	CString cBuffer , cStr;	// obt@	
	CAnalysisEngine cEn;
	// ǂ݂Ƃ
	while(cFile.ReadString(cStr))
	{
		switch(cEn.Analysis(cStr , cBuffer))
		{
		case A_DATE:
			// t
			cDate = cBuffer;
			break;

		case A_SOURCE:
			cSource = cBuffer;
			break;
		case A_TITLE:
			cTitle = cBuffer;
			break;
		case A_URL:

			cUrl =cBuffer;

			
			if(cUrl != _T(""))
			{
				Add(cDate,cSource,cTitle,cUrl);
				// 
				cUrl = _T("");
				cTitle = _T("");
			}

			break;
		case A_SEPARATE:
			// Zp[^Ȃǉ
			if(cUrl != _T(""))
			{
				//Add(cDate,cSource,cTitle,cUrl);
				// 
				cUrl = _T("");
				cTitle = _T("");
			}
			break;

		}	
	}

	// t@C
	cFile.Close();

	return 0;
}

/*----------------------------------------------------------------------------*/
//  T  vF  XgCMoeFileǉ
//    F  lpDate = t , lpSource = \[X , lpTitle = ^Cg , lpUrl = URL
//  ߂lF  void
//    lF  vCx[gȊ֐
/*----------------------------------------------------------------------------*/
void CMoeTop::Add(LPCTSTR lpDate, LPCTSTR lpSource, LPCTSTR lpTitle, LPCTSTR lpUrl)
{
	// ܂͗̈mۂ
	CMoeFile* p_cFile = new CMoeFile;

	// ȂԍtB
	CString cTitle = lpTitle;
	
	while(m_mIndex.find(cTitle) != m_mIndex.end())
	{
		cTitle += _T("0");
	}

	// el
	p_cFile ->SetDate(lpDate);
	p_cFile ->SetSource(lpSource);
	p_cFile ->SetTitle(cTitle);
	p_cFile ->SetUrl(lpUrl);

	// 
	m_liFile.push_back(p_cFile);	// ۂ̃|C^ǉ
	m_mIndex[cTitle] = m_nMax;		// ǗCfbNXǉ
	m_nMax++;						// Ō̃CfbNX₷
}

/*----------------------------------------------------------------------------*/
//  T  vF  CfbNX̍ől擾
//    F  void
//  ߂lF  CfbNX̍ől
//    lF  0n܂
/*----------------------------------------------------------------------------*/
int CMoeTop::GetMaxIndex()
{
	return m_nMax;
}

/*----------------------------------------------------------------------------*/
//  T  vF  w肳ꂽt@C̏Ԃ
//    F  CfbNX
//  ߂lF  CMoeFileւ̃|C^
//    lF  void
/*----------------------------------------------------------------------------*/
CMoeFile* CMoeTop::GetFileInfo(int nIndex)
{
	IT_FILE iFile;
	iFile = m_liFile.begin();

	for(int i=0; i < nIndex ; i++)
	{
		iFile++;
	}
	return *iFile;
}	

BOOL CMoeTop::GetWork()
{
	return m_bWork;
}

void CMoeTop::SetWork(BOOL b)
{
	m_bWork = b;
}

/*----------------------------------------------------------------------------*/
//  T  vF  ^CgCfbNX擾
//    F  ^Cg
//  ߂lF  CfbNX@or -1(s)
//    lF  void
/*----------------------------------------------------------------------------*/
int CMoeTop::GetFileIndex(LPCTSTR lpTitle)
{
	IT_INDEX itIndex;

	itIndex = m_mIndex.find(lpTitle);

	if(itIndex != m_mIndex.end())
	{
		return itIndex->second;
	}else{
		return -1;
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  CfbNXǗ郁oϐNA
//    F  
//  ߂lF  
//    lF  
/*----------------------------------------------------------------------------*/
void CMoeTop::Clear()
{
	m_nMax = 0;

	IT_FILE itFile;
	for(itFile = m_liFile.begin() ;itFile != m_liFile.end() ; itFile++)
	{
		delete *itFile;
	}

	m_mIndex.clear();
	m_liFile.clear();
}

void CMoeTop::Download(int nMode, CString cPath, CString cUrl)
{	
	if(nMode != MOE_ANALYSIS_ONLY)
	{
		// _E[h
		CStdioDownload cHttp;
		if(!cHttp.SaveFile(cUrl , cPath))
		{
			::AfxMessageBox(_T("gbvy[W̃_E[hɎs܂B"));
			return;
		}
	}

	if(nMode != MOE_DOWNLOAD_ONLY)
	{
		// 
		if(ChacheAnalysis(cPath) != 0)
		{
			::AfxMessageBox(_T("͂Ɏs܂B"));
			return;
		}
	}

	return;
}

/*----------------------------------------------------------------------------*/
//  T  vF  _E[hnXbh
//    F  SLoad
//  ߂lF  0
//    lF  _E[hnXbh
/*----------------------------------------------------------------------------*/
UINT CMoeTop::Download(LPVOID pParam)
{
	SLoad *p_stLoad = (SLoad*)pParam;
	p_stLoad ->p_cMoeTop ->SetWork(TRUE);
	
	if(p_stLoad->nMode != MOE_ANALYSIS_ONLY)
	{
		// _E[h
		CStdioDownload cHttp;
		if(!cHttp.SaveFile(p_stLoad->cUrl , p_stLoad ->cFilePath))
		{
			::AfxMessageBox(_T("gbvy[W̃_E[hɎs܂B"));
			p_stLoad ->p_cMoeTop ->SetWork(FALSE);
			return -1;
		}
	}

	if(p_stLoad ->nMode != MOE_DOWNLOAD_ONLY)
	{
		// 
		if(p_stLoad ->p_cMoeTop ->ChacheAnalysis(p_stLoad->cFilePath) != 0)
		{
			::AfxMessageBox(_T("͂Ɏs܂B"));
			p_stLoad ->p_cMoeTop ->SetWork(FALSE);
			return -1;
		}
	}

	p_stLoad ->p_cMoeTop ->SetWork(FALSE);
	return 0;
}
