// SopranoIni.h: CSopranoIni NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SOPRANOINI_H__B624C9AE_ABFE_4328_A5F1_08BAF4531B53__INCLUDED_)
#define AFX_SOPRANOINI_H__B624C9AE_ABFE_4328_A5F1_08BAF4531B53__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Ini.h"
#include "SettingName.h"
enum{
	V_DATE = 0,
	V_SOURCE,
	V_DOUBLE,
	VD_SOURCE,
	V_NORMAL
};
/*----------------------------------------------------------------------------*/
//  Tv        F  SopranoɓCIniNX
//  ֘AtH[F  void
//  l        F  obt@@\B
/*----------------------------------------------------------------------------*/
class CSopranoIni : public CIni  
{
public:
	virtual int SetRefererMode(int nMode);
	virtual int GetReferMode();
	virtual int SetReferer(LPCTSTR lpRef);
	virtual int SetUserAgent(LPCTSTR lpUA);
	virtual CString GetReferer();
	virtual CString GetUserAgent();
	virtual int SetDateFormat(LPCTSTR lpFormat);
	virtual CString GetDateFormat();
	virtual CRect GetAddressRect();
	virtual void SetAddressRect(LPRECT lpRect);
	virtual CRect GetToolbarRect();
	virtual void SetToolbarRect(LPRECT lpRect);
	virtual CString GetInfoID();
	virtual int SetInfoID(LPCTSTR lpID);
	virtual int SetAutoCheck(BOOL b);
	virtual BOOL GetAutoCheck();
	virtual int SetTreeOpenMode(int nMode);
	virtual int GetTreeOpenMode();
	virtual int SetInfoDlgRect(LPRECT lpRect);
	virtual CRect GetInfoDlgRect();
	virtual CString GetInfoUrl();
	virtual int SetInfoUrl(LPCTSTR lpUrl);
	virtual int SetRefreshTiming(int nTime);
	virtual int GetRefreshTiming();
	virtual CSize GetBrowseWindowSize();
	virtual int SetBrowseWindowSize(LPRECT lpRect);
	virtual CRect GetTreeWindowSize();
	virtual int SetTreeWindowSize(LPRECT lpRect);
	virtual int SetTreeMode(int nMode);
	virtual int GetTreeMode();
	virtual int SetMoeUrl(LPCTSTR lpUrl);
	virtual CString GetMoeUrl();
	virtual int SetHome(LPCTSTR lpUrl);
	virtual CString GetHome();
	virtual int SetHomeMode(int nMode);
	virtual int GetHomeMode();
	CSopranoIni();
	virtual ~CSopranoIni();

private:
	int m_nRefererMode;
	CString m_cReferer;
	CString m_cUserAgent;
	CString m_cDateFormat;
	CString m_cInfoID;
	int m_nAutoCheck;
	int m_nTreeOpenMode;
	CRect m_cInfodlgRect;
	CString m_cInfoUrl;
	int m_nRefreshTiming;
	CRect m_cBrowseRect;
	CRect m_cTreeRect;
	int m_nTreeMode;
	CString m_cMoeUrl;
	CString m_cHomeUrl;
	int m_nHomeMode;
};

#endif // !defined(AFX_SOPRANOINI_H__B624C9AE_ABFE_4328_A5F1_08BAF4531B53__INCLUDED_)
