// ShellControl.cpp: CShellControl NX̃Cve[V
// Shelln
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ShellControl.h"
#include <shlobj.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define BIF_NEWDIALOGSTYLE      0x0040 
#define BIF_BROWSEINCLUDEURLS   0x0080 
#define BIF_SHAREABLE           0x8000 
#define BIF_USENEWUI            BIF_NEWDIALOGSTYLE | BIF_EDITBOX

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CShellControl::CShellControl()
{

}

CShellControl::~CShellControl()
{

}

// tH_̎Q
CString CShellControl::RefFolder(HWND hWnd)
{
	BROWSEINFO bi;
	TCHAR szDir[MAX_PATH+1];
	LPITEMIDLIST pidl;
	LPMALLOC pMalloc;

	szDir[0]='\0';

	if (SUCCEEDED(SHGetMalloc(&pMalloc))) {

		ZeroMemory(&bi,sizeof(bi));
		bi.hwndOwner = hWnd;
		// tH_Qƃ_CAO̐eEBhẼnhłB
		// NULLɂƁA[hXɂȂĂ܂݂ł(^^;

		bi.lpszTitle="tH_̎Q"; // \镶łB

		bi.pszDisplayName = 0;
		bi.pidlRoot = 0;

		//bi.ulFlags = BIF_RETURNONLYFSDIRS | BIF_NEWDIALOGSTYLE;
		
		/*
		IvVłBȉ̒ʂB(ORZ\)

		BIF_RETURNONLYFSDIRS I̓t@CVXetH_̂ 
		BIF_BROWSEFORPRINTER I̓v^̂ 
		BIF_BROWSEFORCOMPUTER I̓Rs[^̂ 
		BIF_BROWSESEINCLUDEFILES tH_łȂt@C\ 
		BIF_RETURNFSANCESTORS t@CVXêݑI\ 
		BIF_STATUSTEXT Xe[^XeLXg̕\ 
		BIF_DONTGOBELOWDOMAIN lbg[N܂߂Ȃ 
		*/
		pidl = SHBrowseForFolder(&bi);
		//_CAO\B

		if (pidl)
		{
			//񂪓ꂽȂ...
			SHGetPathFromIDList(pidl,szDir);
			pMalloc->Free(pidl);
			pMalloc->Release();
			return szDir;

		}else{
			return "";
		}

	} else {
		return "";
	}



}

HRESULT CShellControl::CreateShortcut(
                LPSTR pszLink,                          // V[gJbg̐΃pX
                LPSTR pszFile,                          // ^[Qbgt@C
                LPSTR pszDescription,            // 
                LPSTR pszArgs      ,            // 
                LPSTR pszWorkingDir,            // ƃfBNg
                LPSTR pszIconPath,            // ACȐꏊ
                int iIcon,              // ACR̃CfbNX
                int iShowCmd)  // EBhEX^C
{   
	HRESULT hres;
    IShellLink *psl;

    // IShellLink IuWFNg쐬|C^擾
    hres = CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER,
                                            IID_IShellLink, (void **)&psl);
    if (SUCCEEDED(hres))
    {
        IPersistFile *ppf;

        // V[gJbg񎟋Luɕۑ邽 IPersistFile
        // C^[tFCX̖₢킹Ȃ
        hres = psl->QueryInterface(IID_IPersistFile, (void **)&ppf);
        if (SUCCEEDED(hres))
        {
            WORD wsz[MAX_PATH];  // Unicode ւ̃obt@

            psl->SetPath(pszFile);                      // ^[Qbgt@C
            psl->SetDescription(pszDescription);        // 
            psl->SetArguments(pszArgs);                // 
            psl->SetWorkingDirectory(pszWorkingDir);    // ƃfBNg
            psl->SetIconLocation(pszIconPath, iIcon);  // ACR
            psl->SetShowCmd(iShowCmd);                  // EBhEX^C

            // ANSIō\悤ɂ
            MultiByteToWideChar(CP_ACP, 0, pszLink, -1, wsz, MAX_PATH);

            // V[gJbgۑ
            hres = ppf->Save(wsz, TRUE);

            // IPersistFile ւ̃|C^J
            ppf->Release();
        }
        // IShellLinkւ̃|C^J
        psl->Release();
    }
    return hres;

}

HRESULT CShellControl::MakeShortcut(
                LPSTR pszLink,                          // V[gJbg̐΃pX
                LPSTR pszFile,                          // ^[Qbgt@C
                LPSTR pszDescription,            // 
                LPSTR pszArgs ,            // 
                LPSTR pszWorkingDir ,            // ƃfBNg
                LPSTR pszIconPath    ,            // ACȐꏊ
                int iIcon            ,              // ACR̃CfbNX
                int iShowCmd        )  // EBhEX^C{
{
	HRESULT hres;
	if ( SUCCEEDED(CoInitialize(NULL)) ) 
	{
		hres=CreateShortcut(
                pszLink,                          // V[gJbg̐΃pX
                pszFile,                          // ^[Qbgt@C
                pszDescription,            // 
                pszArgs,            // 
                pszWorkingDir,            // ƃfBNg
                pszIconPath,            // ACȐꏊ
                iIcon,              // ACR̃CfbNX
				iShowCmd);
        CoUninitialize();
    }

	return hres;
}

HRESULT CShellControl::GetLink(LPSTR pszLink, LPSTR pszFilePath, int cchMaxPath, WIN32_FIND_DATA *wfd)
{
	HRESULT hres;
    IShellLink *psl;

    // IShellLink IuWFNg쐬|C^擾
    hres = CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER,
                                            IID_IShellLink, (void **)&psl);
    if (SUCCEEDED(hres))
    {
        IPersistFile *ppf;

        // IPersistFile C^[tFCX̖₢킹Ȃ
        hres = psl->QueryInterface(IID_IPersistFile, (void **)&ppf);
        if (SUCCEEDED(hres))
        {
            WORD wsz[MAX_PATH];   // Unicode ւ̃obt@

            // ANSIō\悤ɂ
            MultiByteToWideChar(CP_ACP, 0, pszLink, -1, wsz, MAX_PATH);

            // V[gJbg[h
            hres = ppf->Load(wsz, STGM_READ);

            if (SUCCEEDED(hres))
            {
                // N擾
                hres = psl->GetPath(pszFilePath, cchMaxPath, wfd, SLGP_UNCPRIORITY);
            }

            // IPersistFile ւ̃|C^J
            ppf->Release();
        }
        // IShellLinkւ̃|C^J
        psl->Release();
    }
    return hres;
}

/**
	T  vF  V[gJbg̃N擾
	  F  V[gJbg̃pX
	߂lF@ÑpX
	  lF  
	*/
CString CShellControl::GetLink(CString cLinkPath)
{
	char chBuf[MAX_PATH];
	WIN32_FIND_DATA wfd;
	if ( SUCCEEDED(CoInitialize(NULL)) ) {
		GetLink((LPSTR)(LPCTSTR)cLinkPath,chBuf,MAX_PATH,&wfd);
		CoUninitialize();
	}

	return chBuf;
}

/**
	T  vF  VXetH_(SendTo)̃pX擾
	  F  tH_萔(SHGetSpecialFolderPath()Q)
	߂lF@ = 0
	  lF  
	*/
CString CShellControl::GetSystemFolder(int nFolder)
{
	// tH_̃pX擾
	char chPath[MAX_PATH];
	::SHGetSpecialFolderPath(NULL,chPath,nFolder,0);

	return chPath;


}

int CShellControl::DeleteFile(const CString &rPath)
{
	SHFILEOPSTRUCT stShell;
	stShell.hwnd = NULL;
	stShell.wFunc = FO_DELETE;
	stShell.pFrom = (LPSTR)(LPCTSTR)rPath;
	stShell.fFlags = FOF_ALLOWUNDO | FOF_MULTIDESTFILES | FOF_NOCONFIRMATION;
	return SHFileOperation(&stShell);
}
