// StdioDownload.cpp: CStdioDownload NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "StdioDownload.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CStdioDownload::CStdioDownload()
:m_dwTimeOut(30 * 1000)
{

}

CStdioDownload::~CStdioDownload()
{

}

/*----------------------------------------------------------------------------*/
//  T  vF  w肳ꂽURL̓eǂݍ
//    F  lpUrl = URL
//			  cBuffer = obt@
//  ߂lF   = TRUE
//    lF  void
/*----------------------------------------------------------------------------*/
BOOL CStdioDownload::ReadUrl(LPCTSTR lpUrl, CString &cBuffer)
{
	// Wininet.dll̏
	if(InternetOpen(m_cUA))
	{
		// URLJ
		if(InternetOpenUrl(lpUrl,INTERNET_OPEN_TYPE_PRECONFIG))
		{
			// ^CAEg̐ݒ
			InternetSetOption(INTERNET_OPTION_RECEIVE_TIMEOUT,&m_dwTimeOut);

			while(1)
			{
				DWORD dwMaxSize,dwReadSize;

				// xɓǂݍ߂TCY擾
				InternetQueryDataAvailable(&dwMaxSize,0,0);

				// ̈m
				char *p_chBuffer = new char[dwMaxSize + 1];

				// t@Cǂݏo
				::InternetReadFile(GetServiceHandle() , p_chBuffer , dwMaxSize , &dwReadSize);
				
				if(dwReadSize == 0)	
				{
					delete [] p_chBuffer;
					break;	// I
				}

				p_chBuffer[dwMaxSize] = 0;	// I[NULLZbg

				cBuffer +=p_chBuffer; // PvIobt@ɕۑĂ
				delete [] p_chBuffer;
			}
		}else{
			InternetCloseHandle();
			return FALSE;
		}
		InternetCloseHandle();
	}
	return TRUE;
}

BOOL CStdioDownload::SaveFile(LPCTSTR lpUrl, LPCTSTR lpFile)
{
	// obt@փ_E[h
	CString cBuffer;
	
	if(ReadUrl(lpUrl,cBuffer) == FALSE)
	{
		return FALSE;
	}

	// t@CJ
	CStdioFile cFile;
	CFileException e;
	if(cFile.Open(lpFile,CFile::modeCreate | CFile::modeWrite,&e) == 0)
	{
#ifdef _DEBUG
		afxDump << "File could not be opened " << e.m_cause << "\n";
#endif

		return FALSE;
	}
	
	cFile.WriteString(cBuffer);

	cFile.Close();

	return TRUE;
}

/*----------------------------------------------------------------------------*/
//  T  vF  ^CAEgݒ肷
//    F  ^CAEg̎(1/1000)
//  ߂lF  0
//    lF  ^CAEg͖ݒ̏ꍇ30 * 1000(1/1000b)
/*----------------------------------------------------------------------------*/
int CStdioDownload::SetTimeOut(DWORD dwTime)
{
	m_dwTimeOut = dwTime;
	return 0;
}



CString CStdioDownload::GetUrlPathName(LPCTSTR lpURL)
{
	URL_COMPONENTS uc;

	char Scheme[1000];
	char HostName[1000];
	char UserName[1000];
	char Password[1000];
	char UrlPath[1000];
	char ExtraInfo[1000];

	uc.dwStructSize = sizeof(uc);
	uc.lpszScheme = Scheme;
	uc.lpszHostName = HostName;
	uc.lpszUserName = UserName;
	uc.lpszPassword = Password;
	uc.lpszUrlPath = UrlPath;
	uc.lpszExtraInfo = ExtraInfo;

	uc.dwSchemeLength = 1000;
	uc.dwHostNameLength = 1000;
	uc.dwUserNameLength = 1000;
	uc.dwPasswordLength = 1000;
	uc.dwUrlPathLength = 1000;
	uc.dwExtraInfoLength = 1000;

	InternetCrackUrl(
		lpURL,
		0, 0, &uc);

	return  uc.lpszUrlPath;
	
}

int CStdioDownload::SetUserAgent(const CString &rUA)
{
	m_cUA = rUA;
	return 0;
}
